## ESRI UK provide these materials "as is" and without warranty
## or condition of any kind, either express or implied. These
## materials are for demonstration purposes only and are not
## supported. Any code should be thoroughly tested prior to use
import arcpy, os, sys, string, traceback

try:
#   get path to Temp as we'll use this for layer files etc. later
#
    temp = os.environ.get("temp")
    
    map = arcpy.GetParameterAsText(0)
    Newdatasource = arcpy.GetParameterAsText(1)
    Newdatabase = arcpy.GetParameterAsText(2)

    if arcpy.Exists(temp + r"\demo2Con.sde"):
        os.remove(temp + r"\demo2Con.sde")

    instance="sde:sqlServer:" + Newdatasource
    Newconnection = arcpy.CreateArcSDEConnectionFile_management(temp , "demo2Con.sde", Newdatasource, instance, Newdatabase ,"OPERATING_SYSTEM_AUTH","","","","dbo.default")

    mymap = arcpy.mapping.MapDocument(map)

    for df in arcpy.mapping.ListDataFrames(mymap):
        for l in arcpy.mapping.ListLayers(mymap,"",df):
            arcpy.AddMessage(l.name)
            if l.isGroupLayer:
                pass
            else:
                dsn = Newdatabase + ".dbo." + os.path.basename(l.datasetName).split('.')[0]
                l.replaceDataSource(temp + r"\demo2Con.sde","SDE_WORKSPACE",dsn,"TRUE")

    mymap.saveACopy("repointed_map.mxd")
    arcpy.SetParameterAsText(3,"true")

except:
    arcpy.AddError("error has occurred in script " + sys.argv[0])
    arcpy.AddMessage(arcpy.GetMessages(2))
    arcpy.AddMessage( "Terminating Process")
    arcpy.AddMessage( str(sys.exc_info()[0]))
    arcpy.AddMessage( str(sys.exc_info()[1]))
    arcpy.AddMessage( str(traceback.extract_tb(sys.exc_info()[2])))
    arcpy.SetParameterAsText("false")
